#include "/Volumes/D/Work/BESIII/bes3plotstyle.c"
#include "/Volumes/D/Work/BESIII/bes3plotstyle.h"
#include "RooRealVar.h"
#include <sstream>
#include <fstream>
#include <iostream>
#include <math.h>
#include <iomanip>
#include <ctime>
#include <math.h>

#include "TFile.h"
#include "TCanvas.h"
#include "TGraph.h"
#include "TGraphErrors.h"
#include "TMultiGraph.h"
#include "TLegend.h"
#include "TAxis.h"
#include "TMath.h"
#include "TArrow.h"
#include "TMinuit.h"
#include "TRandom.h"
const double mp=0.93827208816;
const int ncm=8;
using namespace RooFit;

Double_t drawgend(Double_t *x, Double_t *par){
    return 0;
}

Double_t drawgend1(Double_t *x, Double_t *par){
    return 0;
}

Double_t drawgend2(Double_t *x, Double_t *par){
    return 0;
}

Double_t drawgend3(Double_t *x, Double_t *par){
    return 0;
}

void fithm2(){
  SetStyle();
  SetPrelimStyle();
  gSystem->Load("libRooFit");
  gROOT->Reset();
  gStyle->SetCanvasBorderMode(0);
  gStyle->SetCanvasBorderSize(0);
  gStyle->SetCanvasColor(10);
  gStyle->SetLabelFont(42,"xyz");
  gStyle->SetLabelSize(0.06,"xyz");
  gStyle->SetLabelOffset(0.01,"xyz");
  gStyle->SetNdivisions(510,"xyz");
  gStyle->SetTitleFont(42,"xyz");
  gStyle->SetTitleColor(1,"xyz");
  gStyle->SetTitleSize(0.07,"xyz");
  gStyle->SetTitleOffset(1.15,"xyz");
  gStyle->SetPadBorderMode(0);
  gStyle->SetPadBorderSize(0);
  gStyle->SetPadColor(10);
  gStyle->SetPadLeftMargin(0.17);
  gStyle->SetPadBottomMargin(0.2);
  gStyle->SetPadRightMargin(0.05);
  gStyle->SetPadTopMargin(0.05);
  gStyle->SetLegendBorderSize(0);
  gStyle->SetOptDate(0);
  gStyle->SetOptStat(0);
  gStyle->SetOptFit(0);
  gStyle->SetOptTitle(0);
  gStyle->SetOptTitle(kFALSE);

  double cms[ncm], angle[ncm], pu[ncm], pd[ncm], pmean[ncm], L[ncm], estaL[ncm], esysL[ncm];
  double innsig[ncm], innbkg[ncm], lnsig[ncm], lnbkg[ncm], hnsig[ncm], hnbkg[ncm], sr[ncm], st[ncm];
  double inmg1[ncm], insg1[ncm], lmg1[ncm], hmg1[ncm], lsg1[ncm], hsg1[ncm];
  double inmg2[ncm], insg2[ncm], lmg2[ncm], hmg2[ncm], lsg2[ncm], hsg2[ncm];
  double infrac[ncm], lfrac[ncm], hfrac[ncm];
  double inco1[ncm], dco1[ncm], uco1[ncm], inco2[ncm], dco2[ncm], uco2[ncm];
  double nobin[ncm], Yax[ncm], Yhigh[ncm];
  double nsig[ncm], esig[ncm], nBkg[ncm], ebkg[ncm];
  double fraclo[ncm], frachi[ncm];
  double co1lo[ncm], co2lo[ncm], nbkglo[ncm], nsignal1lo[ncm], sg1lo[ncm], mg1lo[ncm], sg2lo[ncm], mg2lo[ncm];
  double co1hi[ncm], co2hi[ncm], nbkghi[ncm], nsignal1hi[ncm], sg1hi[ncm], mg1hi[ncm], sg2hi[ncm], mg2hi[ncm];
  double mul[ncm];
  int RunNod1[ncm], RunNou1[ncm], RunNod2[ncm], RunNou2[ncm];
  TString cmsa[ncm], cmsb[ncm], no[ncm], namei[ncm], Thvarp[ncm], Thvarm[ncm];
  TH1F* hvar[ncm];

  ifstream infile1("../../../cms.txt");
  for(int i=0;i<ncm;i++){
    infile1 >> cmsa[i]>>cmsb[i]>>cms[i]>>RunNod1[i]>>RunNou1[i]>>RunNod2[i]>>RunNou2[i]>>angle[i]>>L[i]>>estaL[i]>>esysL[i];
    namei[i] = "../noPID/mc_"+cmsb[i]+"S_02.root";
    if((cms[i]<2.21)||((cms[i]>2.35)&&(cms[i]<2.85))){
      pu[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))+0.1;
      pd[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))-0.1;
    }
    if((cms[i]>2.85)&&(cms[i]<3.2)){
      pu[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))+0.1;
      pd[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))-0.11;
    }
    if((cms[i]>2.21)&&(cms[i]<2.28)){
      pu[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))+0.1;
      pd[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))-0.11;
    }
    if((cms[i]>2.28)&&(cms[i]<2.35)){
      pu[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))+0.1;
      pd[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))-0.12;
    }
    if((cms[i]>3.2)&&(cms[i]<3.95)){
      pu[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))+0.12;
      pd[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2))-0.15;
    }
    pmean[i]=sqrt(pow((cms[i]/2),2)-pow(mp,2));
    no[i] = Form("%02d", i );
    Thvarp[i]="hvarp_"+cmsa[i];
    Thvarm[i]="hvarm_"+cmsa[i];
    nobin[i]=10000*(pu[i]-pd[i]);
    Yax[i]=0;
  }

  TString indata = "./fitparamh.txt";
  ifstream infile2(indata);

  for(int i=0;i<1;i++){
    infile2>>inmg1[i]>>lmg1[i]>>hmg1[i]>>insg1[i]>>lsg1[i]>>hsg1[i]>>inmg2[i]>>lmg2[i]>>hmg2[i]>>insg2[i]>>lsg2[i]>>hsg2[i]>>infrac[i]>>lfrac[i]>>hfrac[i]>>innsig[i]>>lnsig[i]>>hnsig[i]>>innbkg[i]>>lnbkg[i]>>hnbkg[i]>>inco1[i]>>dco1[i]>>uco1[i]>>inco2[i]>>dco2[i]>>uco2[i]>>sr[i]>>st[i];

    TFile* file1 = new TFile(namei[i]);
    hvar[i] = (TH1F*)file1->Get(Thvarm[i]);
    for(double j=0;j<nobin[i];j++){
      if(Yax[i]<=hvar[i]->GetBinContent(j+1)){Yax[i]=hvar[i]->GetBinContent(j+1);}
    }
    Yhigh[i]=1.3*Yax[i];

    TCanvas *myC2 = new TCanvas("myC2", "myC2", 0, 0, 800, 600);
    TString outlog = "./fith_logm2";
    gSystem->RedirectOutput(outlog);
    gStyle->SetErrorX(0.5);
    RooRealVar x("x", "x", pd[i], pu[i]);
    RooDataHist data("data", "data", x, hvar[i]);
    RooRealVar mg1("mg1", "mg1", inmg1[i], lmg1[i], hmg1[i]);
    RooRealVar sg1("sg1", "sg1", insg1[i], lsg1[i], hsg1[i]);
    RooGaussian gauss1("gauss1","gauss1", x, mg1, sg1);
    RooRealVar mg2("mg2", "mg2", inmg2[i], lmg2[i], hmg2[i]);
    RooRealVar sg2("sg2", "sg2", insg2[i], lsg2[i], hsg2[i]);
    RooGaussian gauss2("gauss2","gauss2", x, mg2, sg2 );
    RooRealVar frac("frac","frac",infrac[i],lfrac[i],hfrac[i]);
    x.setRange("mini", pd[i], pu[i]);
    RooAddPdf gauss("gauss","gauss",RooArgList(gauss1,gauss2),RooArgList(frac));

    RooRealVar co1("co1","coefficienct #1", inco1[i], dco1[i], uco1[i]);
    RooRealVar co2("co2","coefficienct #2", inco2[i], dco2[i], uco2[i]);
    RooChebychev  poly("poly", "poly PDF", x, RooArgList(co1,co2));
    RooRealVar f1("Sig", "fra1", innsig[i], lnsig[i], hnsig[i]);
    RooRealVar f2("Bkg", "fra2", innbkg[i], lnbkg[i], hnbkg[i]);
    RooAddPdf sum("sum", "sig+bak", RooArgList(gauss,poly), RooArgList(f1,f2));
    RooFitResult *fitresult;
    time_t now_time;
    now_time = 12345;
    do{
      fitresult=sum.fitTo(data, Minos(kTRUE), Strategy(2),Save());

        co1lo[i]=0; co2lo[i]=0; nbkglo[i]=0; nsignal1lo[i]=0; sg1lo[i]=0; mg1lo[i]=0; sg2lo[i]=0; mg2lo[i]=0;
        co1hi[i]=0; co2hi[i]=0; nbkghi[i]=0; nsignal1hi[i]=0; sg1hi[i]=0; mg1hi[i]=0; sg2hi[i]=0; mg2hi[i]=0;
        mul[i]=0;
        nsig[i]=f1.getVal();
        esig[i]=f1.getError();
        nBkg[i]=f2.getVal();
        ebkg[i]=f2.getError();
        co1lo[i]=co1.getErrorLo();
        co2lo[i]=co2.getErrorLo();
        nbkglo[i]=f2.getErrorLo();
        nsignal1lo[i]=f1.getErrorLo();
        sg1lo[i]=sg1.getErrorLo();
        mg1lo[i]=mg1.getErrorLo();
        sg2lo[i]=sg2.getErrorLo();
        mg2lo[i]=mg2.getErrorLo();
        fraclo[i]=frac.getErrorLo();
        co1hi[i]=co1.getErrorHi();
        co2hi[i]=co2.getErrorHi();
        nbkghi[i]=f2.getErrorHi();
        nsignal1hi[i]=f1.getErrorHi();
        sg1hi[i]=sg1.getErrorHi();
        mg1hi[i]=mg1.getErrorHi();
        sg2hi[i]=sg2.getErrorHi();
        mg2hi[i]=mg2.getErrorHi();
        frachi[i]=frac.getErrorHi();
        mul[i]=pow(10,85)*co1lo[i]*co2lo[i]*nbkglo[i]*nsignal1lo[i]*sg1lo[i]*mg1lo[i]*sg2lo[i]*mg2lo[i]*fraclo[i]*co1hi[i]*co2hi[i]*nbkghi[i]*nsignal1hi[i]*sg1hi[i]*mg1hi[i]*sg2hi[i]*mg2hi[i]*frachi[i]*(co1lo[i]+co1hi[i])*(co2lo[i]+co2hi[i]);
        cout<<"mul:"<<fabs(mul[i])<<endl;
        cout<<"nsig:"<<nsig[i]<<"+/-"<<esig[i]<<" "<<nsignal1lo[i]<<" "<<nsignal1hi[i]<<"   0.95:"<<sqrt(0.95*nsig[i])<<"   1.3:"<<sqrt(sr[i]*(nsig[i]+nBkg[i]))<<"   nBkg:"<<nBkg[i]<<" "<<ebkg[i]<<" "<<nbkglo[i]<<" "<<nbkghi[i]<<" co:"<<co1lo[i]<<" "<<co1hi[i]<<" "<<co2lo[i]<<" "<<co2hi[i]<<" g1:"<<sg1lo[i]<<" "<<sg1hi[i]<<" "<<mg1lo[i]<<" "<<mg1hi[i]<<" g2:"<<sg2lo[i]<<" "<<sg2hi[i]<<" "<<mg2lo[i]<<" "<<mg2hi[i]<<" frac:"<<fraclo[i]<<" "<<frachi[i]<<" 1: "<<fabs(esig[i]-nsignal1hi[i])<<" 2: "<<fabs(nsignal1lo[i]+nsignal1hi[i])<<" 3: "<<fabs(esig[i]+nsignal1lo[i])<<endl;
        if((fabs(nsignal1lo[i])<sqrt(0.95*nsig[i])) || (fabs(nsignal1hi[i])<sqrt(0.95*nsig[i])) || (fabs(nsignal1lo[i])>sqrt(sr[i]*(nsig[i]+nBkg[i]))) || (fabs(nsignal1hi[i])>sqrt(sr[i]*(nsig[i]+nBkg[i]))) || (fabs(nbkglo[i])>(nBkg[i]+5)) || (fabs(nbkghi[i])>(nBkg[i]+5)) || (fabs(nsignal1lo[i]+nsignal1hi[i])>15) || (fabs(esig[i]-nsignal1hi[i])>15) || (fabs(esig[i]+nsignal1lo[i])>15) || (fabs(mul[i])<1)){
          now_time +=1;
          gRandom->SetSeed(now_time);
          inco1[i] = gRandom->Uniform(dco1[i], uco1[i]);
          inco2[i] = gRandom->Uniform(dco2[i], uco2[i]);
          inmg1[i] = gRandom->Uniform(lmg1[i], hmg1[i]);
          insg1[i] = gRandom->Uniform(lsg1[i], hsg1[i]);
          inmg2[i] = gRandom->Uniform(lmg2[i], hmg2[i]);
          insg2[i] = gRandom->Uniform(lsg2[i], hsg2[i]);
          infrac[i]= gRandom->Uniform(lfrac[i],hfrac[i]);
          innsig[i]= gRandom->Uniform(lnsig[i], hnsig[i]);
          innbkg[i]= gRandom->Uniform(lnbkg[i], hnbkg[i]);
        }
    }
    while((fabs(nsignal1lo[i])<sqrt(0.95*nsig[i])) || (fabs(nsignal1hi[i])<sqrt(0.95*nsig[i])) || (fabs(nsignal1lo[i])>sqrt(sr[i]*(nsig[i]+nBkg[i]))) || (fabs(nsignal1hi[i])>sqrt(sr[i]*(nsig[i]+nBkg[i]))) || (fabs(nbkglo[i])>(nBkg[i]+5)) || (fabs(nbkghi[i])>(nBkg[i]+5)) || (fabs(mul[i])<1));
    RooPlot *xframe=x.frame();
    data.plotOn(xframe);
    sum.plotOn(xframe);
    sum.plotOn(xframe, VisualizeError(*fitresult), Components("poly"), FillColor(kSpring+10));
    sum.plotOn(xframe, VisualizeError(*fitresult), Components("gauss1"), FillColor(kRed-9));
    sum.plotOn(xframe, VisualizeError(*fitresult), Components("gauss2"), FillColor(kViolet-9));
    sum.plotOn(xframe, VisualizeError(*fitresult), FillColor(kAzure+10));
    sum.plotOn(xframe, LineColor(4), LineWidth(3));
    sum.plotOn(xframe,Components("poly"),LineStyle(3), LineColor(kGreen+1), LineWidth(3));
    sum.plotOn(xframe,Components("gauss1"),LineStyle(2), LineColor(2), LineWidth(3));
    sum.plotOn(xframe,Components("gauss2"),LineStyle(2), LineColor(9), LineWidth(3));
    xframe->Draw();
    xframe->GetXaxis()->SetNdivisions(505,kTRUE);
    xframe->GetYaxis()->SetNdivisions(505,kTRUE);
    xframe->GetYaxis()->SetRangeUser(0.0,Yhigh[i]);
    xframe->GetYaxis()->SetMaxDigits(3);
    TGaxis::SetExponentOffset(-0.139, -0.015, "y");

    TString XTitle = "#font[12]{p}_{#bar{#it{p}}} [GeV/#font[12]{c}]";
    TString YTitle2 = Form("%1.1f", 1000*(pu[i]-pd[i])/nobin[i]);
    TString YTitle = "Events/["+ YTitle2 + " MeV/#font[12]{c}]";
    xframe->SetXTitle(XTitle);
    xframe->SetYTitle(YTitle);
    TAxis *yaxis= xframe->GetYaxis();
    TAxis *xaxis= xframe->GetXaxis();
    xaxis->CenterTitle();
    yaxis->CenterTitle();

    long double meana=sqrt(pow(mg1.getVal(),2)*frac.getVal()+pow(mg2.getVal(),2)*(1-frac.getVal()));
    long double gaga=sqrt(pow(sg1.getVal(),2)*frac.getVal()+pow(sg2.getVal(),2)*(1-frac.getVal())+frac.getVal()*(1-frac.getVal())*pow((mg1.getVal()-mg2.getVal()),2));

    TArrow* ar10=new TArrow(meana-4*gaga,0.1,meana-4*gaga,0.3*Yhigh[i],0,"<|");
      ar10->SetAngle(40);
      ar10->SetLineWidth(3);
      ar10->SetLineColor(2);
      ar10->Draw("same");

    TArrow* ar11=new TArrow(meana+3*gaga,0.1,meana+3*gaga,0.3*Yhigh[i],0,"<|");
      ar11->SetAngle(40);
      ar11->SetLineWidth(3);
      ar11->SetLineColor(2);
      ar11->Draw("same");

    TArrow* ar12=new TArrow(meana-5*gaga,0.1,meana-5*gaga,0.3*Yhigh[i],0,"<|");
      ar12->SetAngle(40);
      ar12->SetLineWidth(3);
      ar12->SetLineColor(kBlue+3);
      ar12->Draw("same");

    TArrow* ar13=new TArrow(meana-9*gaga,0.1,meana-9*gaga,0.3*Yhigh[i],0,"<|");
      ar13->SetAngle(40);
      ar13->SetLineWidth(3);
      ar13->SetLineColor(kBlue+3);
      ar13->Draw("same");

    TArrow* ar14=new TArrow(meana+4*gaga,0.1,meana+4*gaga,0.3*Yhigh[i],0,"<|");
      ar14->SetAngle(40);
      ar14->SetLineWidth(3);
      ar14->SetLineColor(kBlue+3);
      ar14->Draw("same");

    TArrow* ar15=new TArrow(meana+7*gaga,0.1,meana+7*gaga,0.3*Yhigh[i],0,"<|");
      ar15->SetAngle(40);
      ar15->SetLineWidth(3);
      ar15->SetLineColor(kBlue+3);
      ar15->Draw("same");

    TF1 *funcgend = new TF1("funcgend",drawgend, 0, 0, 0);
      funcgend->SetLineWidth(3);
      funcgend->SetFillStyle(1001);
      funcgend->SetFillColor(kAzure+10);
      funcgend->SetLineColor(4);
    TF1 *funcgend1= new TF1("funcgend1",drawgend1, 0, 0, 0);
      funcgend1->SetFillStyle(1001);
      funcgend1->SetFillColor(kRed-9);
      funcgend1->SetLineStyle(2);
      funcgend1->SetLineColor(2);
    TF1 *funcgend2= new TF1("funcgend2",drawgend2, 0, 0, 0);
      funcgend2->SetFillStyle(1001);
      funcgend2->SetFillColor(kViolet-9);
      funcgend2->SetLineStyle(2);
      funcgend2->SetLineColor(9);
    TF1 *funcgend3= new TF1("funcgend3",drawgend3, 0, 0, 0);
      funcgend3->SetFillStyle(1001);
      funcgend3->SetFillColor(kSpring+10);
      funcgend3->SetLineStyle(3);
      funcgend3->SetLineColor(kGreen+1);
    TLegend* LE1 = new TLegend(0.65, 0.45, 0.95, 0.95);
    LE1->SetBorderSize(1);
    LE1->SetFillColor(10);
    LE1->SetTextSize(0.06);

    TLegendEntry* L1 = LE1->AddEntry( xframe, "#it{p}#bar{#it{p}} MC",  "ELP");
    L1->SetLineColor(1);
    L1->SetLineWidth(1);
    L1->SetMarkerStyle(20);

    TLegendEntry* L2 = LE1->AddEntry( funcgend, "total fit",  "LF");
    TLegendEntry* L3 = LE1->AddEntry( funcgend1, "gaussian1",  "LF");
    TLegendEntry* L5 = LE1->AddEntry( funcgend2, "gaussian2",  "LF");
    TLegendEntry* L6 = LE1->AddEntry( funcgend3, "background",  "LF");
    LE1->Draw("same");
    myC2->Update();

    TPaveText *p1 = new TPaveText(0.17,0.85,0.55,0.95,"BRNDC");
      p1->SetBorderSize(1);
      p1->SetFillColor(0);
      p1->SetTextAlign(12);
      p1->SetTextFont(42);
      p1->SetTextSize(0.07);

    TString Par6  = "#sqrt{#font[12]{s}}="+cmsa[i]+" GeV ";
    TText *
      text5 = p1->AddText(Par6);
    p1->Draw();

    TString nameeps = "MCfitHP"+no[i]+"m.eps";
    TString namepdf = "MCfitHP"+no[i]+"m.pdf";
    myC2->Update();
    myC2->Print(nameeps);
    myC2->Print(namepdf);

    TString offile = "./fitparam.txt";
    ofstream paras;
    paras.open(offile);
    paras<<setiosflags(ios::fixed)<<setprecision(12)<<mg1.getVal()<<" "<<mg1.getVal()+st[i]*mg1.getErrorLo()<<" "<<mg1.getVal()+st[i]*mg1.getErrorHi()<<"  ";
    paras<<setiosflags(ios::fixed)<<setprecision(12)<<sg1.getVal()<<" "<<sg1.getVal()+st[i]*sg1.getErrorLo()<<" "<<sg1.getVal()+st[i]*sg1.getErrorHi()<<"  ";
    paras<<setiosflags(ios::fixed)<<setprecision(12)<<mg2.getVal()<<" "<<mg2.getVal()+st[i]*mg2.getErrorLo()<<" "<<mg2.getVal()+st[i]*mg2.getErrorHi()<<"  ";
    paras<<setiosflags(ios::fixed)<<setprecision(12)<<sg2.getVal()<<" "<<sg2.getVal()+st[i]*sg2.getErrorLo()<<" "<<sg2.getVal()+st[i]*sg2.getErrorHi()<<"  ";
    paras<<setiosflags(ios::fixed)<<setprecision(12)<<frac.getVal()<<" "<<frac.getVal()+st[i]*frac.getErrorLo()<<" "<<frac.getVal()+st[i]*frac.getErrorHi()<<"  ";
    paras<<setiosflags(ios::fixed)<<setprecision(12)<<f1.getVal()<<" "<<f1.getVal()+st[i]*f1.getErrorLo()<<" "<<f1.getVal()+st[i]*f1.getErrorHi()<<"  ";
    paras<<setiosflags(ios::fixed)<<setprecision(12)<<f2.getVal()<<" "<<f2.getVal()+st[i]*f2.getErrorLo()<<" "<<f2.getVal()+st[i]*f2.getErrorHi()<<"  ";
    paras<<setiosflags(ios::fixed)<<setprecision(12)<<co1.getVal()<<" "<<co1.getVal()+st[i]*co1.getErrorLo()<<" "<<co1.getVal()+st[i]*co1.getErrorHi()<<"  ";
    paras<<setiosflags(ios::fixed)<<setprecision(12)<<co2.getVal()<<" "<<co2.getVal()+st[i]*co2.getErrorLo()<<" "<<co2.getVal()+st[i]*co2.getErrorHi()<<"  ";
    paras<<setiosflags(ios::fixed)<<setprecision(2)<<sr[i]<<"  ";
    paras<<st[i];
    paras<<endl;
  }
gSystem->Exit(0);
}
